export declare const MAX_COLOR_SATURATION = 100;
export declare const MAX_COLOR_HUE = 359;
export declare const MAX_COLOR_VALUE = 100;
export interface IRGB {
    r: number;
    g: number;
    b: number;
    a?: number;
}
export interface IHSV {
    h: number;
    s: number;
    v: number;
}
export interface IColor extends IRGB, IHSV {
    hex: string;
    str: string;
}
export declare function cssColor(color: string): IRGB;
export declare function rgb2hex(r: number, g: number, b: number): string;
export declare function hsv2hex(h: number, s: number, v: number): string;
export declare function rgb2hsv(r: number, g: number, b: number): IHSV;
export declare function hsl2hsv(h: number, s: number, l: number): IHSV;
export declare function hsl2rgb(h: number, s: number, l: number): IRGB;
export declare function hsv2rgb(h: number, s: number, v: number): IRGB;
export declare function getColorFromString(color: string): IColor;
export declare function getFullColorString(color: IColor): string;
export declare function updateSV(color: IColor, s: number, v: number): IColor;
export declare function updateH(color: IColor, h: number): IColor;
export declare function updateA(color: IColor, a: number): IColor;
