import * as React from 'react';
import { IDropdownProps } from './Dropdown.Props';
import { FocusZone } from '../../FocusZone';
import { IWithResponsiveModeState } from '../../utilities/decorators/withResponsiveMode';
import { BaseComponent } from '../../Utilities';
export interface IDropdownInternalProps extends IDropdownProps, IWithResponsiveModeState {
}
export interface IDropdownState {
    isOpen?: boolean;
    selectedIndex?: number;
}
export declare class Dropdown extends BaseComponent<IDropdownInternalProps, IDropdownState> {
    static defaultProps: {
        options: any[];
    };
    private static Option;
    refs: {
        [key: string]: React.ReactInstance;
        root: HTMLElement;
        focusZone: FocusZone;
    };
    private _focusZone;
    private _dropDown;
    private _dropdownLabel;
    private _id;
    constructor(props?: IDropdownProps);
    componentWillReceiveProps(newProps: IDropdownProps): void;
    componentDidUpdate(prevProps: IDropdownProps, prevState: IDropdownState): void;
    render(): JSX.Element;
    focus(): void;
    setSelectedIndex(index: number): void;
    private _onRenderTitle(item);
    private _onRenderContainer(props);
    private _onRenderList(props);
    private _onRenderItem(item);
    private _onRenderOption(item);
    private _onPositioned();
    private _onItemClick(index);
    private _onDismiss();
    private _getSelectedIndex(options, selectedKey);
    private _onDropdownKeyDown(ev);
    private _onZoneKeyDown(ev);
    private _onDropdownClick();
}
