define([], function() { return "import * as React from 'react';\r\nimport { Calendar } from './Calendar';\r\n\r\nexport interface ICalendar {\r\n  /** Sets focus to the selected date. */\r\n  focus(): void;\r\n}\r\n\r\nexport interface ICalendarProps extends React.Props<Calendar> {\r\n  /**\r\n  * Callback issued when a date is selected\r\n  */\r\n  onSelectDate?: (date: Date) => void;\r\n\r\n  /**\r\n   * Callback issued when calendar is closed\r\n   */\r\n  onDismiss?: () => void;\r\n\r\n  /**\r\n   * Whether the month picker is shown beside the day picker or hidden.\r\n   * @defaultvalue true\r\n   */\r\n  isMonthPickerVisible?: boolean;\r\n\r\n  /**\r\n   * Default value of the Calendar, if any\r\n   */\r\n  value?: Date;\r\n\r\n  /**\r\n   * The first day of the week for your locale.\r\n   * @defaultvalue DayOfWeek.Sunday\r\n   */\r\n  firstDayOfWeek?: DayOfWeek;\r\n\r\n  /**\r\n   * @deprecated\r\n   * This property has been removed at 0.80.0 in place of the focus method, to be removed @ 1.0.0.\r\n   *\r\n   */\r\n  shouldFocusOnMount?: boolean;\r\n\r\n  /**\r\n   * Localized strings to use in the Calendar\r\n   */\r\n  strings: ICalendarStrings;\r\n}\r\n\r\nexport enum DayOfWeek {\r\n  Sunday = 0,\r\n  Monday = 1,\r\n  Tuesday = 2,\r\n  Wednesday = 3,\r\n  Thursday = 4,\r\n  Friday = 5,\r\n  Saturday = 6\r\n}\r\n\r\nexport interface ICalendarStrings {\r\n  /**\r\n   * An array of strings for the full names of months.\r\n   * The array is 0-based, so months[0] should be the full name of January.\r\n   */\r\n  months: string[];\r\n\r\n  /**\r\n   * An array of strings for the short names of months.\r\n   * The array is 0-based, so shortMonths[0] should be the short name of January.\r\n   */\r\n  shortMonths: string[];\r\n\r\n  /**\r\n   * An array of strings for the full names of days of the week.\r\n   * The array is 0-based, so days[0] should be the full name of Sunday.\r\n   */\r\n  days: string[];\r\n\r\n  /**\r\n   * An array of strings for the initials of the days of the week.\r\n   * The array is 0-based, so days[0] should be the initial of Sunday.\r\n   */\r\n  shortDays: string[];\r\n\r\n  /**\r\n   * String to render for button to direct the user to today's date.\r\n   */\r\n  goToToday: string;\r\n}\r\n"; });