define([], function() { return "import * as React from 'react';\r\nimport { IRenderFunction } from '../../Utilities';\r\n\r\nexport interface IPivotItemProps extends React.HTMLProps<HTMLDivElement> {\r\n  /**\r\n   * The text displayed of each pivot link.\r\n   */\r\n  linkText?: string;\r\n\r\n  /**\r\n   * An required key to uniquely identify a pivot item.\r\n   *\r\n   * Note: The 'key' from react props cannot be used inside component.\r\n   */\r\n  itemKey?: string;\r\n\r\n  /**\r\n   * The aria label of each pivot link which will read by screen reader instead of linkText.\r\n   *\r\n   * Note that unless you have compelling requirements you should not override aria-label.\r\n   */\r\n  ariaLabel?: string;\r\n\r\n  /**\r\n   * An optional item count that gets displayed just after the linkText(itemCount)\r\n   *\r\n   * Example: completed(4)\r\n   */\r\n  itemCount?: number;\r\n\r\n  /**\r\n   * An optional icon to show next to the pivot link.\r\n   */\r\n  itemIcon?: string;\r\n\r\n  /**\r\n   * Optional custom renderer for the pivot item link\r\n   */\r\n  onRenderItemLink?: IRenderFunction<IPivotItemProps>;\r\n}"; });