module.exports = "import * as React from 'react';\r\nimport { IContextualMenuItem } from '../ContextualMenu/index';\r\n\r\nexport interface ICommandBar {\r\n  /**\r\n   * Sets focus to the active command in the list.\r\n   */\r\n  focus(): void;\r\n}\r\n\r\nexport interface ICommandBarProps extends React.HTMLProps<HTMLDivElement> {\r\n  /**\r\n   * Whether or not the search box is visible\r\n   * @defaultvalue false\r\n   */\r\n  isSearchBoxVisible?: boolean;\r\n\r\n  /**\r\n   * Placeholder text to display in the search box\r\n   */\r\n  searchPlaceholderText?: string;\r\n\r\n  /**\r\n   * Items to render\r\n   */\r\n  items: IContextualMenuItem[];\r\n\r\n  /**\r\n   * Default items to have in the overflow menu\r\n   */\r\n  overflowItems?: IContextualMenuItem[];\r\n\r\n  /**\r\n   * Text to be read by screen readers if there are overflow items and focus is on elipsis button\r\n   */\r\n  elipisisAriaLabel?: string;\r\n\r\n  /**\r\n   * Items to render on the right side (or left, in RTL).\r\n   */\r\n  farItems?: IContextualMenuItem[];\r\n\r\n  /**\r\n   * Additional css class to apply to the command bar\r\n   * @defaultvalue undefined\r\n   */\r\n  className?: string;\r\n}";