module.exports = "import * as React from 'react';\r\nimport { Dialog } from './Dialog';\r\nimport { IButtonProps } from '../Button/Button.Props';\r\nimport { IWithResponsiveModeState } from '../../utilities/decorators/withResponsiveMode';\r\nimport { IAccessiblePopupProps } from '../../common/IAccessiblePopupProps';\r\n\r\nexport interface IDialogProps extends React.Props<Dialog>, IWithResponsiveModeState, IAccessiblePopupProps {\r\n  /**\r\n  * Whether the dialog is displayed.\r\n  * @default false\r\n  */\r\n  isOpen?: boolean;\r\n\r\n  /**\r\n  * The type of Dialog to display.\r\n  * @default DialogType.normal\r\n  */\r\n  type?: DialogType;\r\n\r\n  /**\r\n  * Whether the overlay is dark themed.\r\n  * @default true\r\n  */\r\n  isDarkOverlay?: boolean;\r\n\r\n  /**\r\n  * A callback function for when the Dialog is dismissed from the close button or light dismiss, before the animation completes.\r\n  */\r\n  onDismiss?: (ev?: React.MouseEvent<HTMLButtonElement>) => any;\r\n\r\n  /**\r\n   * A callback function which is called after the Dialog is dismissed and the animation is complete.\r\n   */\r\n  onDismissed?: () => any;\r\n\r\n  /**\r\n  * The title text to display at the top of the dialog.\r\n  */\r\n  title?: string;\r\n\r\n  /**\r\n  * The subtext to display in the dialog.\r\n  */\r\n  subText?: string;\r\n\r\n  /**\r\n  * Whether the dialog can be light dismissed by clicking outside the dialog (on the overlay).\r\n  * @default false\r\n  */\r\n  isBlocking?: boolean;\r\n\r\n  /**\r\n   * Optional class name to be added to the root class\r\n   */\r\n  className?: string;\r\n\r\n  /**\r\n  * Optional override for container class\r\n  */\r\n  containerClassName?: string;\r\n\r\n  /**\r\n  * Optional override content class\r\n  */\r\n  contentClassName?: string;\r\n\r\n  /**\r\n   * A callback function for when the Dialog content is mounted on the overlay layer\r\n   */\r\n  onLayerDidMount?: () => void;\r\n\r\n  /**\r\n   * @deprecated\r\n   * Use onLayerDidMount instead. Deprecated at 0.81.2, to be removed at 1.0.0.\r\n   */\r\n  onLayerMounted?: () => void;\r\n\r\n  /**\r\n   * Other top buttons that will show up next to the close button\r\n   */\r\n  topButtonsProps?: IButtonProps[];\r\n}\r\n\r\nexport enum DialogType {\r\n  /** Standard dialog */\r\n  normal = 0,\r\n  /** Dialog with large header banner */\r\n  largeHeader = 1,\r\n  /** Dialog with an 'x' close button in the upper-right corner */\r\n  close = 2\r\n}";