module.exports = "import * as React from 'react';\r\n\r\nexport interface IFocusTrapZone {\r\n  /**\r\n  * Sets focus on the first focusable child in focus trap zone\r\n  */\r\n  focus: () => void;\r\n}\r\n\r\nexport interface IFocusTrapZoneProps extends React.HTMLProps<HTMLDivElement> {\r\n  /**\r\n   * Sets the HTMLElement to focus on when exiting the FocusTrapZone.\r\n   * @default The element.target that triggered the FTZ.\r\n   */\r\n  elementToFocusOnDismiss?: HTMLElement;\r\n\r\n  /**\r\n   * Sets the aria-labelledby attribute.\r\n   */\r\n  ariaLabelledBy?: string;\r\n\r\n  /**\r\n   * Indicates if this Trap Zone will allow clicks outside the FocusTrapZone\r\n   * @default false\r\n   */\r\n  isClickableOutsideFocusTrap?: boolean;\r\n\r\n  /**\r\n   * Indicates if this Trap Zone will ignore keeping track of HTMLElement that activated the Zone.\r\n   * @default false\r\n   */\r\n  ignoreExternalFocusing?: boolean;\r\n\r\n   /**\r\n   * Indicates whether focus trap zone should force focus inside the focus trap zone\r\n   * @default true\r\n   */\r\n  forceFocusInsideTrap?: boolean;\r\n\r\n   /**\r\n   * Indicates the selector for first focusable item\r\n   */\r\n  firstFocusableSelector?: string;\r\n}\r\n";