module.exports = "import * as React from 'react';\r\n\r\nexport interface IMessageBarProps extends React.HTMLProps<HTMLElement> {\r\n\r\n  /**\r\n   * The type of MessageBar to render.\r\n   * @defaultvalue MessageBarType.info\r\n   */\r\n  messageBarType?: MessageBarType;\r\n\r\n  /**\r\n   * The actions you want to show on the other side.\r\n   */\r\n  actions?: JSX.Element;\r\n\r\n  /**\r\n   * A description of the message bar for the benefit of screen readers.\r\n   */\r\n  ariaLabel?: string;\r\n\r\n  /**\r\n   * Whether the message bar has a dismiss button and its callback.\r\n   * If null, we don't show a dismiss button.\r\n   * @defaultvalue null\r\n   */\r\n  onDismiss?: (ev?: React.MouseEvent<HTMLButtonElement>) => any;\r\n\r\n  /**\r\n   * Determines if the message bar is multi lined.\r\n   * If false, and the text overflows over buttons or to another line, it is clipped.\r\n   * @defaultvalue true\r\n   */\r\n  isMultiline?: boolean;\r\n\r\n   /**\r\n   * Aria label on dismiss button if onDismiss is defined.\r\n   */\r\n  dismissButtonAriaLabel?: string;\r\n}\r\n\r\nexport enum MessageBarType {\r\n  /** Info styled MessageBar */\r\n  info = 0,\r\n  /** Error styled MessageBar */\r\n  error = 1,\r\n  /** Blocked styled MessageBar */\r\n  blocked = 2,\r\n  /** SevereWarning styled MessageBar */\r\n  severeWarning = 3,\r\n  /** Success styled MessageBar */\r\n  success = 4,\r\n  /** Warning styled MessageBar */\r\n  warning = 5,\r\n  /**\r\n   * @deprecated\r\n   * Deprecated at v0.48.0, to be removed at >= v1.0.0. Use 'blocked' instead.\r\n   */\r\n  remove = 6\r\n}\r\n";