module.exports = "import * as React from 'react';\r\n\r\nimport { Pivot } from './Pivot';\r\nimport { PivotItem } from './PivotItem';\r\n\r\nexport interface IPivotProps extends React.Props<Pivot> {\r\n  /**\r\n   * The index of the pivot item initially selected.\r\n   *\r\n   * It only works when initialSelectedKey is not defined. You must not use them together.\r\n   */\r\n  initialSelectedIndex?: number;\r\n\r\n  /**\r\n   * The key of the pivot item initially selected.\r\n   *\r\n   * It will make initialSelectedIndex not work. You must not use them together.\r\n   */\r\n  initialSelectedKey?: string;\r\n\r\n  /**\r\n   * The key of the selected pivot item.\r\n   *\r\n   * If set, this will override the Pivot's selected item state.\r\n   */\r\n  selectedKey?: string;\r\n\r\n  /**\r\n   * Callback issued when the selected pivot item is changed\r\n   */\r\n  onLinkClick?: (item?: PivotItem, ev?: React.MouseEvent<HTMLElement>) => void;\r\n\r\n  /**\r\n   * Specify the PivotLinkSize to use (normal, large)\r\n   */\r\n  linkSize?: PivotLinkSize;\r\n\r\n  /**\r\n   * Specify the PivotLinkFormat to use (links, tabs)\r\n   */\r\n  linkFormat?: PivotLinkFormat;\r\n\r\n}\r\n\r\nexport enum PivotLinkFormat {\r\n  /**\r\n   * Display Pivot Links as links\r\n   */\r\n  links = 0,\r\n\r\n  /**\r\n   * Display Pivot Links as Tabs\r\n   */\r\n  tabs = 1\r\n}\r\n\r\nexport enum PivotLinkSize {\r\n\r\n  /**\r\n   * Display Link using normal font size\r\n   */\r\n  normal = 0,\r\n\r\n  /**\r\n   * Display links using large font size\r\n   */\r\n  large = 1\r\n}\r\n";