module.exports = "import * as React from 'react';\r\n\r\n/**\r\n * Rating component props.\r\n */\r\nexport interface IRatingProps extends React.HTMLProps<HTMLElement> {\r\n  /**\r\n   * Selected rating, has to be an integer between min and max\r\n   */\r\n  rating?: number;\r\n\r\n  /**\r\n   * Minimum rating, defaults to 1, has to be >= 0\r\n   */\r\n  min?: number;\r\n\r\n  /**\r\n   * Maximum rating, defaults to 5, has to be >= min\r\n   */\r\n  max?: number;\r\n\r\n  /**\r\n   * Custom icon, defaults to FavoriteStar\r\n   */\r\n  icon?: string;\r\n\r\n  /**\r\n   * Size of rating, defaults to small\r\n   */\r\n  size?: RatingSize;\r\n\r\n  /**\r\n   * Callback when the rating has changed\r\n   */\r\n  onChanged?: (rating: number) => void;\r\n\r\n  /**\r\n   * Optional label for star ratings, will be read by screen readers, defaults to 'Star'.\r\n   */\r\n  ariaLabelIcon?: string;\r\n\r\n  /**\r\n   * Optional id of label describing this instance of Rating\r\n   */\r\n  ariaLabelId?: string;\r\n}\r\n\r\nexport enum RatingSize {\r\n  Small = 0,\r\n  Large = 1\r\n}";