module.exports = "import * as React from 'react';\r\nimport { TeachingBubble } from './TeachingBubble';\r\nimport { TeachingBubbleContent } from './TeachingBubbleContent';\r\nimport { IImageProps } from '../../Image';\r\nimport { IButtonProps } from '../../Button';\r\nimport { IAccessiblePopupProps } from '../../common/IAccessiblePopupProps';\r\nimport { ICalloutProps } from '../../Callout';\r\n\r\n/**\r\n * TeachingBubble component props.\r\n */\r\n\r\nexport interface ITeachingBubbleProps extends React.Props<TeachingBubble | TeachingBubbleContent>, IAccessiblePopupProps {\r\n  /**\r\n   * Properties to pass through for Callout, reference detail properties in ICalloutProps\r\n   */\r\n  calloutProps?: ICalloutProps;\r\n\r\n  /**\r\n   * A headline for the Teaching Bubble.\r\n   */\r\n  headline?: string;\r\n\r\n  /**\r\n   * A variation with smaller bold headline and no margins.\r\n   */\r\n  hasCondensedHeadline?: boolean;\r\n\r\n  /**\r\n   * Does the TeachingBubble have a close button in the top right corner?\r\n   */\r\n  hasCloseIcon?: boolean;\r\n\r\n  /**\r\n   * An Image for the Teaching Bubble.\r\n   */\r\n  illustrationImage?: IImageProps;\r\n\r\n  /**\r\n   * The Primary interaction button\r\n   */\r\n  primaryButtonProps?: IButtonProps;\r\n\r\n  /**\r\n   * The Secondary interaction button\r\n   */\r\n  secondaryButtonProps?: IButtonProps;\r\n\r\n  /**\r\n   * Element to anchor the TeachingBubble to.\r\n   */\r\n  targetElement?: HTMLElement;\r\n\r\n  /**\r\n   * Callback when the TeachingBubble tries to close.\r\n   */\r\n  onDismiss?: (ev?: any) => void;\r\n}";