module.exports = "import * as React from 'react';\r\nimport { Tooltip } from './Tooltip';\r\nimport { ICalloutProps } from '../../Callout';\r\nimport { DirectionalHint } from '../../common/DirectionalHint';\r\n\r\n/**\r\n * Tooltip component props.\r\n */\r\n\r\nexport interface ITooltipProps extends React.HTMLProps<HTMLDivElement | Tooltip> {\r\n  /**\r\n   * Properties to pass through for Callout, reference detail properties in ICalloutProps\r\n   */\r\n  calloutProps?: ICalloutProps;\r\n\r\n  /**\r\n   *  String to be passed to the tooltip\r\n   */\r\n  content?: string;\r\n\r\n  /**\r\n   * Length of delay. Can be set to zero if you do not want a delay.\r\n   * @default medium\r\n   */\r\n  delay?: TooltipDelay;\r\n\r\n  /**\r\n   * Element to anchor the Tooltip to.\r\n   */\r\n  targetElement?: HTMLElement;\r\n\r\n  /**\r\n   * Indicator of how the tooltip should be anchored to its targetElement.\r\n   * @default DirectionalHint.topCenter\r\n   */\r\n  directionalHint?: DirectionalHint;\r\n}\r\n\r\nexport enum TooltipDelay {\r\n  zero = 0,\r\n  medium = 1\r\n}";